> For the complete documentation index, see [llms.txt](https://developers.make.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.make.com/custom-apps-documentation/app-components/rpcs/dynamic-fields-rpc.md).

# Dynamic fields RPC

The dynamic fields RPC generates dynamic fields inside a module. You can do this by adding a couple of properties to the `output` with some modification to match the syntax of the app builder.

## Details to consider

* Pay attention to the `type`. For example, Make doesn't accept `"type": "string"`. In this case, you need to change it to `"type": "text"`.
* Specify the `name` for a field. Otherwise, you will not be able to access it in the communication of a module.
* Properly convert field types between your service types and Make types. One of the ways to resolve it is to use [custom IML functions](/custom-apps-documentation/app-components/iml-functions/dynamic-mappable-parameters.md).

The rest of the properties (like `options`, `default`, `nested`, etc.) are also available and can be used according to the selected parameter type. The only difference is that instead of creating parameters manually you create dynamic parameters.

{% tabs %}
{% tab title="Source" %}

```json
{
    "response": {
        "iterate": "{{body}}",
        "output": {
            "name": "{{item.key}}",
            "label": "{{item.label}}",
            "type": "text",
            "required": "{{item.isRequired == 1}}"
        }
    }
}
```

{% endtab %}
{% endtabs %}

## Examples

### RPC with only dynamic parameters

{% tabs %}
{% tab title="Source" %}

```json
[
    "rpc://nameOfMyRemoteProcedure"
]
```

{% hint style="info" %}
You might need to implement a [custom IML function](/custom-apps-documentation/app-components/iml-functions/dynamic-mappable-parameters.md) if the service types of fields don't match with Make types.
{% endhint %}
{% endtab %}
{% endtabs %}

### RPC with custom fields (additional dynamic parameters)

{% tabs %}
{% tab title="Source" %}

```json
[
    {
        "name": "defaultField",
        "label" : "Default Field",
        "type": "text"
    },
    
    "rpc://nameOfMyRemoteProcedure"
]
```

{% endtab %}
{% endtabs %}

### Select parameter with nested dynamic parameters under a specific option

{% tabs %}
{% tab title="Source" %}

```json
[
    {
        "name": "param",
        "label": "Parameter",
        "type": "select",
        "options": [
            {
                "label": "Option 1",
                "value": 1,
                "nested": "rpc://NameOfMyRemoteProcedure"
            }
        ]
    }
]
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers.make.com/custom-apps-documentation/app-components/rpcs/dynamic-fields-rpc.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
